/*
 * Define a Sun format audio file header.
 *
 * The byte ordering of this structure should not be assumed; convert it
 * to network byte-order before performing any other operations on it.
 *
 */
struct _audio_hdr{
	u_long		magic;		/* magic number		*/
	u_long		hdr_size;	/* size of this header	*/
	u_long		data_size;	/* length of data	*/
	u_long		data_encoding;	/* data encoding format */
	u_long		sample_rate;	/* samples per second	*/
	u_long		channels;	/* number of channels	*/
};
typedef struct _audio_hdr Audio_hdr;


/* Define the magic number */
#define	AUDIO_FILE_MAGIC		((u_long)0x2e736e64)

/* Define the encoding fields (use Sun's names for compatability) */
#define	AUDIO_FILE_ENCODING_MULAW_8	(1)	/* 8-bit ISDN u-law */
#define	AUDIO_FILE_ENCODING_LINEAR_8	(2)	/* 8-bit linear PCM */
#define	AUDIO_FILE_ENCODING_LINEAR_16	(3)	/* 16-bit linear PCM */
#define	AUDIO_FILE_ENCODING_LINEAR_24	(4)	/* 24-bit linear PCM */
#define	AUDIO_FILE_ENCODING_LINEAR_32	(5)	/* 32-bit linear PCM */
#define	AUDIO_FILE_ENCODING_FLOAT	(6)	/* 32-bit IEEE floating point */
#define	AUDIO_FILE_ENCODING_DOUBLE	(7)	/* 64-bit IEEE floating point */
